local function add_loot(inst,itemname,base,extra)
	local x = math.random()*extra + base
	while x >=1 do
		inst.components.lootdropper:AddChanceLoot(itemname, 1)
		x = x - 1
	end
end

local function add_chance_loot(inst,itemname,probability)
	inst.components.lootdropper:AddChanceLoot(itemname, probability)
end

local function event_spawn(inst,itemname,prob)
	local x = math.random()
	if x< prob then
		inst.components.lootdropper:SpawnLootPrefab(itemname)
	end
end

local function GetConf(name)
	local res = GetModConfigData(name)
	if type(res) == "string" then
		res = GLOBAL.tonumber(res)
	end
	return res
end

function rare_event_spawn(inst)
	local boost = GetConf("dig unpickable drop change boost")
	if inst.components.pickable and inst.components.pickable:CanBePicked() then
		event_spawn(inst,"silk",GetConf("rare silk"))
		event_spawn(inst,"spidergland",GetConf("rare spidergland"))
		boost = GetConf("dig drop change boost")
	end

	if inst:HasTag("tree") then
		boost = GetConf("chop tree drop change boost")
		event_spawn(inst,"silk",GetConf("rare silk"))
		event_spawn(inst,"spidergland",GetConf("rare spidergland"))
		event_spawn(inst,"spider",GetConf("rare spider"))

		x = 1
		while x<=GetConf("deciduous tree more log") do
			event_spawn(inst,"log",GetConf("deciduous tree more log probability"))
			x = x + 1
		end
		
		event_spawn(inst,"feather_crow",GetConf("rare feather"))
		event_spawn(inst,"feather_robin",GetConf("rare feather"))
		event_spawn(inst,"rocks",GetConf("rare rock"))
		event_spawn(inst,"flint",GetConf("rare flint"))
	end

	event_spawn(inst,"dragonfly",GetConf("rare big boss") )
	event_spawn(inst,"deerclops",GetConf("rare boss") )
	event_spawn(inst,"moose",GetConf("rare boss") )
	event_spawn(inst,"bearger",GetConf("rare boss") )
	event_spawn(inst,"mandrake",GetConf("rare boss") )
	event_spawn(inst,"knight",GetConf("rare knight") * boost)
	event_spawn(inst,"rook",GetConf("rare knight") * boost)
	event_spawn(inst,"dragon_scales",GetConf("rare dragon_scales") * boost)
	event_spawn(inst,"gear",GetConf("rare gear") * boost)
	event_spawn(inst,"marble",GetConf("rare marble") * boost)
	event_spawn(inst,"bluegem",GetConf("rare bluegem") * boost)
	event_spawn(inst,"redgem",GetConf("rare redgem") * boost)

end

function add_rare_event(inst)
	if inst.components.workable then
		local fn = inst.components.workable.onfinish
		inst.components.workable:SetOnFinishCallback(function (inst,caller) 
			rare_event_spawn(inst)
			fn(inst,caller)
		end)
	end 
end

function more_grass(inst)
	inst.components.pickable:SetUp("cutgrass", TUNING.GRASS_REGROW_TIME,7)
end

function more_twig(inst)
    inst.components.pickable:SetUp("twigs", TUNING.SAPLING_REGROW_TIME,5)
end

function more_reeds(inst)
	if math.random() < 0.2 then 
		inst.components.pickable:SetUp("cutreeds", TUNING.REEDS_REGROW_TIME,12)
	else
		inst.components.pickable:SetUp("cutreeds", TUNING.REEDS_REGROW_TIME,4)
	end
end

AddPrefabPostInit("grass",more_grass)
AddPrefabPostInit("sapling",more_twig)
AddPrefabPostInit("reeds",more_reeds)


function tree_m(inst)
	add_loot(inst,"log",GetConf("evergreen more log"),GetConf("evergreen more log lucky"))
	if (inst.components.growable) then
		local x = inst.components.growable.stage
		add_loot(inst,"log",GetConf("evergreen more log size increase")*x , 0 )
	end
	
end

function rock_m(inst)
	add_loot(inst,"rocks",GetConf("more rocks"),GetConf("more rocks lucky"))
	add_loot(inst,"flint",GetConf("more flint"),GetConf("more flint lucky"))
end

function gold_m(inst)
	add_loot(inst,"goldnugget",GetConf("more goldnugget"),GetConf("more goldnugget lucky"))
	add_loot(inst,"nitre",GetConf("more nitre"),GetConf("more nitre lucky"))
end

function meet_m(inst)
	add_loot(inst,"meat",GetConf("more meat"),GetConf("more meat lucky"))
	add_chance_loot(inst,"pigskin",GetConf("drop pigskin probability"))
end

AddPrefabPostInit("evergreen_sparse",tree_m)
AddPrefabPostInit("evergreen",tree_m) 

AddPrefabPostInit("rock1",rock_m)
AddPrefabPostInit("rock2",gold_m)


AddPrefabPostInit("grass",add_rare_event)
AddPrefabPostInit("deciduoustree",add_rare_event)
AddPrefabPostInit("sapling",add_rare_event)
AddPrefabPostInit("berrybush",add_rare_event)

AddPrefabPostInit("beefalo",meet_m)



